' Jasc Soccer Just Another Sensi Clone - a try to make a sensi clone by Pitto
' a must
'HP http://www.pittographic.com/?page_id=2
#Include "fbgfx.bi"

'this is the language I use
Using FB

'oh yea, I like random numbers, They're so useful and funny! :)
Randomize Timer
'#DEFINE#################################################################################

#define GAME_NAME "JASC SOCCER"
#define GAME_VERSION "0.19.5a"
#define GAME_AUTHOR "Pitto"

'USEFUL CONSTS###########################################################################
'no change x and y, please, or the gk may get crazy :O
Const PITCH_X As Integer = 50
Const PITCH_Y As Integer = 50
'pitch dimensions
Const PITCH_W As Integer = 768 'use a 32 multiplier the pitch texture may fit better!
Const PITCH_H As Integer = 992 'idem
Const PITCH_PENALTY_AREA As Single = PITCH_W*0.30 'see update players sub for details
'net dimensions
Const PITCH_NET_W As Integer = 100
Const PITCH_NET_H As Integer = 25
Const PITCH_MIDDLE_W As Integer = PITCH_W\2 + PITCH_X
Const PITCH_MIDDLE_H As Integer = PITCH_H\2 + PITCH_Y
'net positions
Const PITCH_NET_TOP_Y As Integer = PITCH_W\2+PITCH_Y
Const PITCH_NET_BOTTOM_Y As Integer = PITCH_W\2+PITCH_Y+PITCH_H
'TACTIC CONSTS --------------------------------------------------------------------------
'tiles on the pitch *NO CHANGE THIS VALUE PLEASE!*** JASC MAY CRASH :(
Const TILES_N_TOT As Integer = 35
Const COL_TOT_N As Integer = 6
Const ROW_TOT_N As Integer = 6
'PHYSICS CONSTS -------------------------------------------------------------------------
'gravity acceleration
Const GRAVITY_ACCEL As Single = 9.80665f
'friction of the ball bouncing on the pitch
Const BOUNCE_FRICTION As Single = 0.85f
'friction of the air
Const AIR_FRICTION As Single = 0.98f
'friction of the pitch
Const FRICTION As Single = 0.9f
'maximum speed the ball can reach so it doesn't become a ball flame
Const BALL_MAX_SPEED As Integer = 20
'minimum speed of the ball
Const BALL_MIN_SPEED As Single = 0.5f
Const GRAVITY As Single = 0.980665f
'TRIGONOMETRIC CONSTS--------------------------------------------------------------------
Const PI As Single = 3.14159265f
Const PI_2 As Single = PI/2
Const _2PI_1_8 As Single = PI/4
Const _2PI_2_8 As Single = PI/2
Const _2PI_3_8 As Single = PI*0.75
Const _2PI_5_8 As Single = PI + _2PI_1_8
Const _2PI_6_8 As Single = PI + PI/2
Const _2PI_7_8 As Single = PI + PI*0.75
Const _2PI As Single = PI*2
Const _2PI8 As Single = _2PI_1_8
'DISPLAY CONSTS -------------------------------------------------------------------------
'screen width and height
'IMPORTANT! -> Not less than 450 x 200 or the sprites may load badly
Const SCREEN_W As Integer = 640
Const SCREEN_H As Integer = 480
'useful to don't allow the camera to move everywere, this sets a limit
Const CAMERA_PADDING As Integer = 45
'ratio of the xy movements of the camera having the ball as reference point
Const CAMERA_EASING_RATIO As Integer = 6
'PLAYERS CONSTS--------------------------------------------------------------------------
'players for each team *SAME AS ABOVE* :(
#define PL_N_TOT 11
'default speed of the players
#define PL_DEFAULT_SPEED 1.45f
'delay of the player before executing another action
#define PL_DELAY_TIME 50
#define PL_DELAY_FALLING 10
#define PL_DELAY_FALLED 20
'minimum distance between two players - see check_pl_collisions sub for details
#define PL_MIN_DIST 8
'minimum distance from opponent pl to allow pl owner of the ball to run to the net
#define PL_RUN_SPACE 80
'total number of the player sprites
#define PL_SPRITES_TOT_N 168

'lenght in ms of the sleep statement
#define SLEEP_TIME 17

'colors
#define C_BLACK &h000000
#define C_WHITE &hFFFFFF
#define C_GRAY &h7F7F7F
#define C_RED &hFF0000
#define C_BLUE &h0000FF
#define C_GREEN &h00FF00
#define C_YELLOW &hFFFF00
#define C_CYAN &h00FFFF
#define C_LILIAC &h7F00FF
#define C_ORANGE &hFF7F00
#define C_PURPLE &h7F007F
#define C_DARK_RED &h7F0000
#define C_DARK_GREEN &h007F00
#define C_DARK_BLUE &h00007F

'kit predefined colors
#define C_KIT_HAIR RGB(23,23,23)
#define C_KIT_SHIRT RGB(0,0,127)
#define C_KIT_PANTS RGB(127,127,255)
#define C_KIT_SHOES RGB(63,63,63)
#define C_KIT_LINE RGB(43,154,209)
#define C_KIT_SKIN RGB(255,125,20)
#define C_KIT_SOCKS RGB(63,0,63)


'TYPES
Type camera_proto
  Dim x As Single
  Dim y As Single
  Dim w As Single
  Dim h As Single
  Dim speed As Single
  Dim rds As Single
End Type

Type player_proto
  Dim id As Integer       'unique id of the player 0-PL_N_TOT*2
  Dim team As Integer     ' 0  for home team - 1 for away team
  Dim number As Integer   'number of the player
  Dim label As String * 32 'name of the player    *out of order
  Dim old_x As Single     'old x position
  Dim old_y As Single     'old y position
  Dim x As Single         'x position
  Dim y As Single         'y position
  Dim z As Single         'z position
  Dim rds As Single       'rotation of the player (in radiants (0-6.28))
  Dim tact_offset_x As Integer 'offset x to the tactic
  Dim tact_offset_y As Integer 'offset y to the tactic
  Dim speed_default As Single     'speed defualt of the player
  Dim speed As Single     'speed of the player
  Dim speed_max As Single 'maximum speed that the player can reach
  Dim accel As Single     'acceleration delta    *out of order
  Dim frame As Integer    'useful to get the correct sprite frame
  Dim frame_offset As Integer 'useful to get the correct sprite frame
  Dim dist As Single  'distance covered by the pl
  Dim w As Integer        'width
  Dim ball_radius As Integer 'maximum distance to get the ball    *out of order
  Dim active As Integer ' check if the player is ready to make an action
  'ACTION: 0 none; 1 Running; 2 Jumping; 3 Sliding; 4 Falling; 5 Falled;
  '6 Goalkeeping Jump
  Dim action As Integer
  Dim delay As Integer ' how many cycles delays the player to perform  an action
  Dim skin As Integer
  'skin color: 0: white with black hair; 1: brown with black hair;
  '2:white with yellow hair;
End Type

Type ball_proto
  Dim x As Single         'x position
  Dim y As Single         'y position
  Dim z As Single         'z position
  Dim old_x As Single
  Dim old_y As Single
  Dim z_speed As Single       'z accel ratio
  Dim z_speed_init As Single   'z accel ratio
  Dim speed As Single     'speed
  Dim w As Integer  'width
  Dim rds As Single 'rotation
  Dim effect As Single 'effect
  Dim frame As Integer 'which frame
End Type

'SHARED VARIABLES----------------------------------------------------------------------------
Dim Shared DEBUG As Integer

Dim Shared goal_team_0 As Integer
Dim Shared goal_team_1 As Integer

Dim Shared tct_tile(0 To 9, 0 To 35) As Integer 'tactic array
'it indicates in wich `a` tile the pl must go if the ball is in `b` tile
'for example: ball in tile 20, pl must go to tile 12
'see also functions `get_tact_tile`, `get_rds_from_tile`,
'`get_dist_from_tile` and `get_ball_tile`
'and sub `load_tact`

Dim Shared bhv_tile(0 To 35, 0 To 9) As Integer 'behavior array
'it gives a percentage table for the behavior of the players owners of the ball
'see relative sub for details

Dim Shared pl_sprite_0(PL_SPRITES_TOT_N) As Any Ptr ' A pointer that points to a memory buffer (for plrs sprites)
Dim Shared pl_sprite_1(PL_SPRITES_TOT_N) As Any Ptr ' A pointer that points to a memory buffer (for plrs sprites)
Dim Shared gk_sprite(PL_SPRITES_TOT_N) As Any Ptr ' A pointer that points to a memory buffer (for plrs sprites)
Dim Shared ball_sprite(15) As Any Ptr '  A pointer that points to a memory buffer (for ball sprites)
Dim Shared net_sprite(2) As Any Ptr '  A pointer that points to a memory buffer (for net sprites)
Dim Shared pitch_sprite(2) As Any Ptr '  A pointer that points to a memory buffer (for pitch sprites)
Dim Shared banner_sprite As Any Ptr 'idem for banner
Dim Shared shadowed_sprite As Any Ptr 'idem for shadowed sprite

Dim Shared workpage As Integer ' buffer holding the player sprites
Dim Shared addframe As Integer  'to be soon removed

Dim Shared c_x_o As Single  'camera x offset
Dim Shared c_y_o As Single  'camera y offset

Dim Shared camera As camera_proto 'camera type
Dim Shared pl(PL_N_TOT*2) As player_proto 'player type
Dim Shared ball As ball_proto 'ball type

Dim Shared PL_target_id As Integer = -1 '-1: none; 0-etc. indicates the id of the pl that's receiving pass
Dim Shared PL_ball_owner_id As Integer = -1 '-1: none; 0-etc. indicates the id of the pl owning the ball
Dim Shared PL_ball_owner_delay As Integer = PL_DELAY_TIME*2 'for how much time owning the ball after the touch
Dim Shared PL_team_owner_id As Integer = -1 'indicates the id of the team owning the ball

Dim Shared SHELL_message As String * 64 'this is useful for debug, to store and display shell-like messages

'action input key - in this case the "S" key on the keyboard
Dim Shared Key_pressed As Integer
Dim Shared Key_released As Integer
Dim Shared Key_pressed_time_start As Double
Dim Shared Key_pressed_time_stop As Double

'checks if the match is PC vs PC or Human vs PC
Dim Shared Human_control As Integer

Dim Shared Match_time_start As Double

Dim Shared MATCH_event As Integer = -1 'indicates the actual match event
' -1 none; 0   ; 1 in action; 2 ball off upper side; 3 ball off lower side
' 4 ball off left side; 5 ball off right side; 6 freekick; 7 penalty

'USEFUL VARIABLES----------------------------------------------------------------------------
Dim count As Integer

'init camera dimensions
camera.w = SCREEN_W
camera.h = SCREEN_H
camera.x = PITCH_MIDDLE_W
camera.y = PITCH_MIDDLE_H

' FUNCTIONS DECLARATIONS---------------------------------------------------------------------
'converts radiants to degree
Declare Function r_t_d (degree As Integer) As Integer
' converts degree to radiants
Declare Function d_t_r (degree As Integer) As Single
' calculates the angle between two points
Declare Function a_b_t_p (x1 As Single, y1 As Single, x2 As Single, y2 As Single) As Single
' calculates the distance between two points
Declare Function d_b_t_p (x1 As Single, y1 As Single, x2 As Single, y2 As Single) As Single
' calculates the starting frame for the player sprite from the angle in radiants
Declare Function start_frame (radiants As Single) As Integer
' calculates in wich pitch tile the player must go (use it if the player hasn't the ball possession)
Declare Function get_tact_tile (pl_id As Integer) As Integer
' returns in wich tile is the ball
Declare Function get_ball_tile(team As Integer) As Integer
' calculate the radiants to get the right tile
Declare Function get_rds_from_tile(tile As Integer, pl_x As Single, pl_y As Single) As Single
' calculate the distance between player and the tile where he must go
Declare Function get_dist_from_tile(tile As Integer, pl_x As Single, pl_y As Single) As Single
' return the nearest player to the ball
Declare Function get_nrst_pl_ball(n_team As Integer) As Integer
' giving the id of the team returns the nearest player to pass the ball
Declare Function get_nrst_pl_pass(pl_id As Integer) As Integer
' giving the id of the team returns the 2nd nearest player to pass the ball
Declare Function get_nrst2_pl_pass(pl_id As Integer, order As Integer) As Integer
' giving the unique id of the player calculate wich is his team
' and return the farrest player to pass the ball
Declare Function get_farrest_pl_to_pass(pl_id As Integer) As Integer    '*out of order
' giving the unique id of the player calculate wich is his team and
'return the player nearest to the corner line
Declare Function get_endline_pl_to_pass(pl_id As Integer) As Integer
' giving the unique id of the player calculate wich is his team and
'return the player nearest to middlefield
Declare Function get_centerest_pl_to_pass(pl_id As Integer) As Integer
' giving the unique id of the player owner of the ball
' calculate wich is his team and returns the right player to pass by longside
Declare Function get_longside_pl_to_pass (pl_id As Integer) As Integer
' giving the unique id of the player owner of the ball
' calculate wich is his team and returns the right player to pass by shortside
Declare Function get_shortside_pl_to_pass (pl_id As Integer) As Integer
'giving the distance between pl an pl to pass returns the correct speed of the ball
Declare Function get_passing_ball_speed (dist As Single) As Single
'this function returns 1 if the object is into the camera crop - useful to use less CPU timing for
'drawing functions
Declare Function is_in_camera_crop (x As Single, y As Single, diam As Integer) As Integer
'cheks if the pl can perform a slide
Declare Function is_ball_slidable (c As Integer) As Integer
'cheks if the pl can perform an headkick
Declare Function is_ball_headkickable (c As Integer) As Integer
'checks if the ball is controllable by human player
Declare Function is_ball_controllable_by_human (c As Integer) As Integer
'return the field of view of the player - based upon the player rds
Declare Function is_in_pl_fieldview (c As Integer, pl_to_pass As Integer) As Integer

'SUBS DECLARATIONS-----------------------------------------------------------------------
'load fonts
Declare Sub load_fonts()
'load tactics
Declare Sub load_tact()
'load behavior of the player owner of the ball
Declare Sub load_behavior()
'get user input to control the direction of the player
Declare Sub get_user_input_ways(c As Integer)
'load sprites
Declare Sub load_bitmap()
'paints the kits of the teams with a custom color - and also the color of the skin of
'the players
Declare Sub paint_kits(C_shirt_0 As Integer, C_pants_0 As Integer, C_socks_0 As Integer, _
C_shirt_1 As Integer, C_pants_1 As Integer, C_socks_1 As Integer)
'delete the sprites
Declare Sub delete_bitmap()
'cheks if the sprites have been rightly loaded
Declare Sub check_bitmap()
'draws the nets
Declare Sub draw_top_net()
Declare Sub draw_bottom_net()
'draws the pitch
Declare Sub draw_pitch()
'update the ball
Declare Sub update_ball()
'draw the grid
Declare Sub draw_grid()
'draws the players
Declare Sub draw_players()
'resets the position of the players (0's ids on the left side, 1's ids on the right side)
Declare Sub reset_players_positions()
'puts the ball into the centre of the pitch
Declare Sub ball_put_on_centre()
' update the beahovior of the players
Declare Sub update_players()
' checks if the ball gest the limits of the pitch
' or if the ball goes into any net
Declare Sub ball_border_pitch_limit_check()
'updates the position of the camera following the ball with easing effect
Declare Sub camera_update_position()
'initialize the players proprietes
Declare Sub init_players_proprietes()
'sets to 0 axis z of the ball and z_Speed of the ball
Declare Sub reset_ball_z()
'draws the ball
Declare Sub draw_ball()
'giving the id of the player who owns the ball, calculate in wich tile is,
'it manages the player behavior (for example: running to the net, passing, shooting, etc...)
Declare Sub get_pl_behavior(pl_id As Integer)
'checks if two or more players collide
Declare Sub check_pl_collisions()
'a player without ball and far away from the ball must run the tactic
Declare Sub run_tactic(c As Integer)
'draws the bottom infos
Declare Sub draw_bottom_info()
'aknowledgements
Declare Sub draw_aknowledgements()
'intro
Declare Sub draw_intro()

Sub draw_aknowledgements()
ScreenSet 0, 0
Color , RGB(0, 0, 64)
Cls
Do'clear the keybuffer
Loop While Len(InKey)
Color C_WHITE
Print
Print "            A K N O W L E D G E M E N T S"
Color C_ORANGE
Print
Print " - Lachie Dazdarian - for his tutorials about creating a game in FB"
Print
Print " - I3I2UI/I0 for his very useful code tips and cleanup"
Print
Print " - The Fbgfx developers"
Print
Print " - The FreeBasic Developers"
Print
Print " - The FBIde Developers"
Print
Print " - All the followers of the"
Print "   http://www.freebasic.net/forum/viewtopic.php?p=183438#p183438"
Print "   thread"
Print
Print " OKAY, THANK YOU... press a key to QUIT"
Print " Bye!"
GetKey

End Sub
Sub draw_intro()
  Dim As Integer x,y,erg,buttons,choice

  ScreenSet 0, 0
  Color C_YELLOW, C_BLUE
  Cls

  Print
  Print " J A S C   S O C C E R"
  Print " version " + Str(GAME_VERSION)
  Print
  Print " use arrow keys to move"
  Print " CTRL to slide, jump, kick and so on..."
  Print
  Print " Do you want to play against the PC?"
  Color C_WHITE, C_RED
  Print
  Print " [Y]es"
  Print
  Print " [N]o ";
  Color C_YELLOW, C_BLUE
  Print   " I will watch only the match"
  Print
  Color C_WHITE, C_RED
  Print " [ESC]";
  Color C_YELLOW, C_BLUE
  Print " I really don't have enough spare time, bye bye"

  Do
    choice = Asc(InKey)
    If GetMouse (x, y,, buttons)=0 Then
      If (buttons And 1) Then
        If x>8 And x<49 Then
          If y>125 And y<140 Then choice = 121
          If y>153 And y<168 Then choice = 110
          If y>181 And y<196 Then choice = 27
        EndIf
      EndIf
    EndIf
  Loop Until choice = 121 Or choice = 110 Or choice = 27

  If choice = 121 Then Human_control = 1
  If choice = 110 Then Human_control = 0
  If choice =  27 Then
    draw_aknowledgements()
    delete_bitmap()
    End 'ends the program
  End If
  SetMouse , , 0
  Color C_WHITE

End Sub

Sub load_fonts()
  '    draw string
End Sub

Sub load_bitmap()
  Dim img_x As Integer
  Dim img_w As Integer
  Dim img_y As Integer
  Dim img_h As Integer
  Dim count As Integer
  Dim action As Integer
  Dim offset As Integer

  'loading players sprites------------------------------------------------------------
  img_w = 21
  img_h = 25
  img_x = 0
  img_y = 0
  'load and stores the sprites into two array
  'one array for each team then with paint_kits sub
  'the color of the kits of the sprites will be changed
  BLoad "img\pl_sprites.bmp", 0
  'it loads three time the same sprite because so after it will be painted
  'with custom skin colors (see player_proto type for details)
  'decomment check_bitmap SUB if you want to check the result
  For count = 0 To PL_SPRITES_TOT_N -1
    If (count > 0) And (count Mod 21 = 0) Then
      img_x = 0
      img_y += img_h
    End If
    pl_sprite_0(count) = ImageCreate (img_w, img_h)
    pl_sprite_1(count) = ImageCreate (img_w, img_h)
    gk_sprite(count) = ImageCreate (img_w, img_h)
    Get (img_x, img_y)-(img_x + 20, img_y + 24), pl_sprite_0(count)
    Get (img_x, img_y)-(img_x + 20, img_y + 24), pl_sprite_1(count)
    Get (img_x, img_y)-(img_x + 20, img_y + 24), gk_sprite(count)
    img_x += img_w
  Next count

  '-----------------------------------------------------------------------------------

  'loading ball sprites
  BLoad "img\ball_sprites.bmp", 0
  img_x = 0
  img_y = 0
  For count = 0 To 14
    ball_sprite(count) = ImageCreate (img_w, img_h)
    Get (img_x, img_y)-(img_x + 15, img_y + 15), ball_sprite(count)
    img_x += 16
  Next count

  'loading net sprites
  BLoad "img\net_0.bmp",0
  net_sprite(0) = ImageCreate(106,38)
  Get (0,0)-(105,37), net_sprite(0)
  BLoad "img\net_1.bmp",0
  net_sprite(1) = ImageCreate(106,38)
  Get (0,0)-(105,37), net_sprite(1)

  'loading pitch grass
  BLoad "img\pitch.bmp",0
  pitch_sprite(0) = ImageCreate(32,32)
  Get (0,0)-(31,31), pitch_sprite(0)
  pitch_sprite(1) = ImageCreate(32,32)
  Get (32,0)-(63,31), pitch_sprite(1)

  'loading advertising banner
  BLoad "img\banner.bmp",0
  banner_sprite = ImageCreate(256,24)
  Get (0,0)-(255,23), banner_sprite

  'loading the shadowet texture
  BLoad "img\shadowed.bmp",0
  shadowed_sprite = ImageCreate(32,32)
  Get (0,0)-(31,31), shadowed_sprite
End Sub

Sub paint_kits(C_shirt_0 As Integer, C_pants_0 As Integer, C_socks_0 As Integer, _
  C_shirt_1 As Integer, C_pants_1 As Integer, C_socks_1 As Integer)

  Dim pitch As Integer
  Dim pixels As Any Ptr
  Dim count As Integer
  Dim As Integer img_w
  Dim As Integer img_h

  For count = 0 To PL_SPRITES_TOT_N - 1
    If ImageInfo( pl_sprite_0(count),img_w ,img_h,, pitch, pixels ) Then
      Print "unable to retrieve image information."
      Sleep
      End
    End If
    'Paint the sprite white the selected color image by directly manipulating pixel memory.
    For y As Integer = 0 To img_h
      Dim row As Integer Ptr = pixels + y * pitch

      For x As Integer = 0 To img_w
        If row[x] = C_KIT_SHIRT Then
          row[x] = C_SHIRT_0
        End If
        If row[x] = C_KIT_PANTS Then
          row[x] = C_PANTS_0
        End If
        If row[x]= C_KIT_LINE Then
          row[x] = C_PANTS_0
        End If
        If row[x] = C_KIT_SOCKS Then
          row[x] = C_SOCKS_0
        End If
        '            if count < PL_SPRITES_TOT_N then
        '                if row[x] = C_KIT_SKIN then
        '                    row[x] = &h533300
        '                end if
        '            end if

      Next x

    Next y
    If ImageInfo( pl_sprite_1(count),img_w ,img_h,, pitch, pixels ) Then
      Print "unable to retrieve image information."
      Sleep
      End
    End If
    'Paint the sprite white the selected color image by directly manipulating pixel memory.
    For y As Integer = 0 To img_h
      Dim row As Integer Ptr = pixels + y * pitch

      For x As Integer = 0 To img_w
        If row[x] = C_KIT_SHIRT Then
          row[x] = C_SHIRT_1
        End If
        If row[x] = C_KIT_PANTS Then
          row[x] = C_PANTS_1
        End If
        If row[x]= C_KIT_LINE Then
          row[x] = C_PANTS_1
        End If
        If row[x] = C_KIT_SOCKS Then
          row[x] = C_SOCKS_1
        End If
      Next x
    Next y
  Next count
End Sub

Sub check_bitmap()
  Dim As Integer img_x
  Dim As Integer img_y
  Dim As Integer count

  ScreenLock ' Lock the screen
  ScreenSet workpage, workpage Xor 1 ' Swap work pages.
  For count = 0 To PL_SPRITES_TOT_N - 1
    If (count > 0) And (count Mod 21 = 0) Then
      img_x = 0
      img_y += 20
    End If
    Put (img_x,img_y), pl_sprite_0(count),Trans
    Draw String (img_x,img_y), Str(count)
    img_x += 28
  Next count
  workpage Xor = 1 ' Swap work pages.
  Flip
  ScreenUnLock ' Unlock the page to display what has been drawn on the screen
  Sleep
  img_x = 0
  img_y = 0
  Cls

  For count = 0 To PL_SPRITES_TOT_N - 1
    If (count > 0) And (count Mod 21 = 0) Then
      img_x = 0
      img_y += 20
    End If
    Put (img_x,img_y), pl_sprite_1(count),Trans
    Draw String (img_x,img_y), Str(count)
    img_x += 28
  Next count
  workpage Xor = 1 ' Swap work pages.
  Flip
  ScreenUnLock ' Unlock the page to display what has been drawn on the screen
  Sleep 1000

  For count = 0 To PL_SPRITES_TOT_N - 1
    If (count > 0) And (count Mod 21 = 0) Then
      img_x = 0
      img_y += 20
    End If
    Put (img_x,img_y), gk_sprite(count),Trans
    Draw String (img_x,img_y), Str(count)
    img_x += 28
  Next count
  workpage Xor = 1 ' Swap work pages.
  Flip
  ScreenUnLock ' Unlock the page to display what has been drawn on the screen
  Sleep 1000
  '    img_x = 20
  '    img_y = 20
  '    for count = 0 to PL_SPRITES_TOT_N - 1
  '        cls
  '        PUT (img_x,img_y), pl_sprite_0(count),trans
  '        PUT (img_x + 50,img_y), pl_sprite_1(count),trans
  '        draw string (img_x,img_y+20), str(count)
  '        draw string (img_x,img_y+40), hex(count)
  '        flip
  '        sleep 35
  '    next count

End Sub

Sub delete_bitmap()
  Dim count As Integer
  For count = 0 To PL_SPRITES_TOT_N - 1
    If pl_sprite_0(count) Then ImageDestroy pl_sprite_0(count)
    If pl_sprite_1(count) Then ImageDestroy pl_sprite_1(count)
  Next
  For count = 0 To 14
    If ball_sprite(count) Then ImageDestroy ball_sprite(count)
  Next
  If net_sprite(0)   Then ImageDestroy net_sprite(0)
  If net_sprite(1)   Then ImageDestroy net_sprite(1)
  If pitch_sprite(0) Then ImageDestroy pitch_sprite(0)
  If pitch_sprite(1) Then ImageDestroy pitch_sprite(1)
  If banner_sprite   Then ImageDestroy banner_sprite
  If shadowed_sprite Then ImageDestroy shadowed_sprite
End Sub

Sub draw_pitch()
  Dim As Integer pitch_rows, pitch_cols
  Dim As Integer a, b
  Dim banner_message As String*32
  pitch_rows = PITCH_H \ 32
  pitch_cols = PITCH_W \ 32

  Paint (SCREEN_W\2,SCREEN_H\2), &h3B6F16

  'banner
  Put (PITCH_X + 10 - c_x_o, PITCH_Y - 27 - c_y_o), banner_sprite, Trans
  banner_message = GAME_NAME + " " + Str(GAME_VERSION) + " ::: "
  Draw String (PITCH_X + 15 - c_x_o,  PITCH_Y - 20 - c_y_o), banner_message, RGB(50,50,50)

  Put (PITCH_X + PITCH_W - 266 - c_x_o, PITCH_Y - 27 - c_y_o), banner_sprite, Trans
  banner_message = Str(Goal_team_0) + " - " + Str(Goal_team_1)
  Draw String (PITCH_X + PITCH_W - 256 - c_x_o,  PITCH_Y - 20 - c_y_o), banner_message, RGB(50,50,50)
  'drawing the grass
  For a = 0 To pitch_rows -1
    For b = 0 To pitch_cols -1
      If is_in_camera_crop (PITCH_X + b*32, PITCH_Y + a*32, 128) Then
        If a Mod 2 = 0 Then
          Put (PITCH_X + (b*32)- c_x_o, PITCH_Y+(a*32) - c_y_o),pitch_sprite(0),Trans
        Else
          Put (PITCH_X + (b*32)- c_x_o, PITCH_Y+(a*32) - c_y_o),pitch_sprite(1),Trans
        End If
      End If
    Next b
  Next a
  'drawing the pitch's border lines
  Line (PITCH_X - c_x_o, PITCH_Y - c_y_o)-(PITCH_W+PITCH_X- c_x_o, PITCH_H+PITCH_Y- c_y_o),C_WHITE,b

  'middle line and circle
  Line (PITCH_X - c_x_o, PITCH_MIDDLE_H - c_y_o)-(PITCH_X + PITCH_W - c_x_o, PITCH_MIDDLE_H - c_y_o),C_WHITE
  Circle (PITCH_MIDDLE_W - c_x_o, PITCH_Y + PITCH_H\2- c_y_o), 84,C_WHITE,,,0.8f
  Circle (PITCH_MIDDLE_W - c_x_o, PITCH_Y + PITCH_H\2- c_y_o), 2,C_WHITE,,,,F

  'Top penalty area
  Line    (PITCH_MIDDLE_W - PITCH_PENALTY_AREA - c_x_o,_
  PITCH_Y - c_y_o)-_
  (PITCH_MIDDLE_W + PITCH_PENALTY_AREA - c_x_o,_
  PITCH_Y + PITCH_PENALTY_AREA/1.5f - c_y_o), C_WHITE,B
  'Top Gk area
  Line    (PITCH_MIDDLE_W - PITCH_PENALTY_AREA\2 - c_x_o,_
  PITCH_Y - c_y_o)-_
  (PITCH_MIDDLE_W + PITCH_PENALTY_AREA\2 - c_x_o,_
  PITCH_Y + PITCH_PENALTY_AREA\4 - c_y_o), C_WHITE,B
  'top penalty dish
  Circle (PITCH_MIDDLE_W - c_x_o, PITCH_Y + PITCH_PENALTY_AREA/1.5f - 48 - c_y_o), 2,C_WHITE,,,,F
  'top penalty circle
  Circle (PITCH_MIDDLE_W - c_x_o, PITCH_Y + PITCH_PENALTY_AREA/1.5f - 48 - c_y_o),_
  84,C_WHITE,3.75f,5.65f

  'bottom penalty area
  Line    (PITCH_MIDDLE_W - PITCH_PENALTY_AREA - c_x_o,_
  PITCH_Y + PITCH_H - c_y_o)-_
  (PITCH_MIDDLE_W + PITCH_PENALTY_AREA - c_x_o,_
  PITCH_Y + PITCH_H - PITCH_PENALTY_AREA/1.5f - c_y_o), C_WHITE,B
  'bottom Gk area
  Line    (PITCH_MIDDLE_W - PITCH_PENALTY_AREA\2 - c_x_o,_
  PITCH_Y + PITCH_H - c_y_o)-_
  (PITCH_MIDDLE_W + PITCH_PENALTY_AREA\2 - c_x_o,_
  PITCH_Y + PITCH_H - PITCH_PENALTY_AREA\4 - c_y_o), C_WHITE,B
  'bottom penalty dish
  Circle (PITCH_MIDDLE_W - c_x_o, PITCH_Y + PITCH_H - PITCH_PENALTY_AREA/1.5f + 48 - c_y_o), 2,C_WHITE,,,,F
  'bottom penalty circle
  Circle (PITCH_MIDDLE_W - c_x_o, PITCH_Y + PITCH_H - PITCH_PENALTY_AREA/1.5f + 48 - c_y_o),_
  84,C_WHITE,0.61f,2.52f

  Circle (PITCH_X - c_x_o, PITCH_Y - c_y_o), 9, C_WHITE,pi*1.5f,0
  Circle (PITCH_X - c_x_o, PITCH_Y + PITCH_H - c_y_o), 9, C_WHITE,0,pi/2
  Circle (PITCH_X+PITCH_W - c_x_o, PITCH_Y - c_y_o), 9, C_WHITE,pi,pi*1.5f
  Circle (PITCH_X+PITCH_W - c_x_o, PITCH_Y + PITCH_H - c_y_o), 9, C_WHITE,pi/2,pi
End Sub

Sub get_user_input_action(c As Integer)
  Dim gap As Single
  'by default no key is released
  Key_released = 0

  If MultiKey(SC_CONTROL) And key_pressed = 0 Then
    Key_pressed = 1
    Key_released = 0
    Key_pressed_time_start = Timer
    Exit Sub
  End If
  If Not MultiKey(SC_CONTROL) And key_pressed = 1 Then
    Key_pressed = 0
    Key_released = 1
    Key_pressed_time_stop = Timer
  End If
  ' if the CTRL key has been released then...
  If (Key_released) And PL_ball_owner_id = c Then
    gap = Key_pressed_time_stop - Key_pressed_time_start
    Key_released = 0
    Key_pressed = 0
    Shell_message = Str(gap) + " - KEY CTRL Released"
    reset_ball_z()
    ball.rds = pl(c).rds
    If gap < 0.5f Then
      'passing
      If is_in_pl_fieldview (c, get_nrst_pl_pass(c)) Then
        ball.rds = a_b_t_p (pl(c).x, pl(c).y,pl(get_nrst_pl_pass(c)).x,pl(get_nrst_pl_pass(c)).y)+Rnd*.3f-0.15f
        ball.speed = get_passing_ball_speed (d_b_t_p(pl(c).x, pl(c).y,_
        pl(get_nrst_pl_pass(c)).x,pl(get_nrst_pl_pass(c)).y))
        PL_target_id = get_nrst_pl_pass(c)
        PL_ball_owner_id = c
        PL_team_owner_id = pl(c).team
        pl(c).delay = 10
      Else
        ball.speed = 15
        pl(c).delay = 10
      End If
    Else
      'shooting
      ball.speed = pl(c).speed + 15 * gap
      ball.z_speed = 11
      ball.z_speed_init = ball.z_speed
      pl(c).delay = 10
    End If
    PL_ball_owner_id = c
    PL_team_owner_id = pl(c).team
    pl(c).delay = 10
  End If
End Sub

Sub get_user_input_ways(c As Integer)
  'checks if the user is pressing two cursor key in the same time
  Dim As Integer input_diagonal
  'debug key check
  If MultiKey(SC_D) Then DEBUG Xor = 1
  If MultiKey(SC_SPACE) Then
    ball.z_speed = 12
    ball.z_speed_init = ball.z_speed
  EndIf

  'cursor keys------------------------------------------------------------------------
  If MultiKey(SC_UP) And MultiKey(SC_RIGHT) Then
    input_diagonal = 1
    pl(c).rds = _2PI8
    pl(c).speed = pl(c).speed_default
  End If
  If MultiKey(SC_UP) And MultiKey(SC_LEFT) Then
    input_diagonal = 1
    pl(c).rds = _2PI8 * 3
    pl(c).speed = pl(c).speed_default
  End If
  If MultiKey(SC_DOWN) And MultiKey(SC_LEFT) Then
    input_diagonal = 1
    pl(c).rds = _2PI8 * 5
    pl(c).speed = pl(c).speed_default
  End If
  If MultiKey(SC_DOWN) And MultiKey(SC_RIGHT) Then
    input_diagonal = 1
    pl(c).rds = _2PI8 * 7
    pl(c).speed = pl(c).speed_default
  End If
  If input_diagonal = 0 Then
    If MultiKey(SC_UP) Then
      pl(c).rds = _2PI8*2
      pl(c).speed = pl(c).speed_default
    End If
    If MultiKey(SC_LEFT) Then
      pl(c).rds = PI
      pl(c).speed = pl(c).speed_default
    End If
    If MultiKey(SC_RIGHT) Then
      pl(c).rds = 0
      pl(c).speed = pl(c).speed_default
    End If
    If MultiKey(SC_DOWN) Then
      pl(c).rds = _2PI8*6
      pl(c).speed = pl(c).speed_default
    End If
  End If
  If MultiKey(SC_CONTROL) And is_ball_headkickable(c) And Pl_ball_owner_id <> c Then
    shell_message = " - KEY CTRL Headkick"
    pl(c).speed = 12
    pl(c).delay = 10
    pl(c).action = 2 '2 = headkicking
    Exit Sub
  End If
  If MultiKey(SC_CONTROL) And PL_ball_owner_id <> c Then
    shell_message = " - KEY CTRL slide"
    pl(c).speed = 15
    pl(c).delay =  20
    pl(c).action = 3 '3 = sliding
    Exit Sub
  End If
End Sub

Sub update_ball()

  ball.old_x = ball.x
  ball.old_y = ball.y
  'this to desn't allow the ball to become a missile
  If ball.speed > BALL_MAX_SPEED Then ball.speed = BALL_MAX_SPEED
  If ball.speed < BALL_MIN_SPEED Then ball.speed = 0

  'ball bounce physics
  If ball.z_speed > 0 Then
    ball.z += ball.z_speed - GRAVITY_ACCEL
    ball.z_speed *= GRAVITY
    ball.speed = ball.speed * AIR_FRICTION
    If (ball.z <= 0) Then
      ball.z_speed_init *= BOUNCE_FRICTION
      ball.z_speed = ball.z_speed_init
      ball.z = 0
    End If
  Else
    If ball.z < 0.5f Then ball.z = 0
    ball.speed = ball.speed * friction
  End If

  'ball position
  ball.x += Cos(ball.rds)*ball.speed
  ball.y += -Sin(ball.rds)*ball.speed

  'radiants check -> MOD 2*PI
  If ball.rds > PI*2 Then ball.rds = ball.rds - PI*2
  If ball.rds < 0 Then ball.rds = ball.rds + PI*2
End Sub

Sub draw_ball()
  Dim offset_frame As Integer
  Dim x As Integer

  If (ball.z > 25) Then
    If ball.z < 60 Then
      offset_frame = 5
    Else
      offset_frame = 10
    End If
  Else
    offset_frame = 0
  End If

  If d_b_t_p(ball.x, ball.y, ball.old_x, ball.old_y) > 1 Then
    ball.frame += 1
  End If

  If ball.frame Mod 5 = 0  Then ball.frame = 0

  'shadow
  Circle (ball.x-c_x_o, ball.y-c_y_o+2),ball.w, RGB(0,50,0),,,,F
  Put (ball.x-c_x_o-8, ball.y- 8 - ball.z- c_y_o), ball_sprite(ball.frame + offset_frame), Trans
End Sub

Sub ball_border_pitch_limit_check()
  'goal check team 0
  If  (ball.x > PITCH_MIDDLE_W - PITCH_NET_W\2) And _
    (ball.x < PITCH_MIDDLE_W + PITCH_NET_W\2) And _
    (ball.y < PITCH_Y + 5) And ball.z < PITCH_NET_H Then
    ball_put_on_centre()
    reset_players_positions()
    goal_team_0 +=1
    camera.speed = 0
    PL_ball_owner_id = -1
    Exit Sub
  End If
  If  (ball.x > PITCH_MIDDLE_W - PITCH_NET_W\2) And _
    (ball.x < PITCH_MIDDLE_W + PITCH_NET_W\2) And _
    (ball.y > PITCH_Y + PITCH_H - 5) And _
    ball.z < PITCH_NET_H Then
    ball_put_on_centre()
    reset_players_positions()
    goal_team_1 += 1
    camera.speed = 0
    PL_ball_owner_id = -1
    Exit Sub
  End If

  'border pitch limit check
  If (ball.x + ball.w > PITCH_X+PITCH_W) Then
    ball.x = PITCH_X+PITCH_W-5
    ball.rds = PI - ball.rds
    ball.speed *= 0.3f
    ball.z_speed *= 0.5f
    PL_ball_owner_id = -1
  End If
  If (ball.x - ball.w < PITCH_X) Then
    ball.x = PITCH_X+5
    ball.rds = PI - ball.rds
    ball.speed *= 0.3f
    ball.z_speed *= 0.5f
    PL_ball_owner_id = -1
  End If
  If (ball.y + ball.w > PITCH_Y+PITCH_H) Then
    ball.y = PITCH_Y+PITCH_H-5
    ball.rds = PI*2 - ball.rds
    ball.speed *= 0.3f
    ball.z_speed *= 0.5f
    PL_ball_owner_id = -1
  End If
  If (ball.y - ball.w < PITCH_Y) Then
    ball.y = PITCH_Y+5
    ball.rds = PI*2 - ball.rds
    ball.speed *= 0.3f
    ball.z_speed *= 0.5f
    PL_ball_owner_id = -1
  End If
End Sub

Sub draw_grid()
  Dim As Integer x, y, x2,y2, col, row, count
  For row = 0 To ROW_TOT_N -1 Step 1
    For col = 0 To COL_TOT_N -1 Step 1
      'draw the grid
      x = col * PITCH_W \ COL_TOT_N + PITCH_X
      y = row * PITCH_H \ ROW_TOT_N + PITCH_Y
      x2 = x + PITCH_W \ COL_TOT_N
      y2 = y + PITCH_H \ ROW_TOT_N
      Line (x-c_x_o,y-c_y_o)-(x2-c_x_o,y2-c_y_o),RGB(255,0,255),b
      Draw String (x+5-c_x_o,y+5-c_y_o), Str(count), RGB(75,150,20)
      'check if the ball is into a box of the grid and fill it using paint function
      If (ball.x > x) And (ball.x < x2) And (ball.y>y) And (ball.y < y2) Then
        Paint (ball.x-c_x_o, ball.y-c_y_o),RGB(50,150,15),RGB(255,0,255)
        Draw String (x+5-c_x_o,y+5-c_y_o), Str(count)
      End If
      count +=1
    Next col
  Next row
End Sub

Sub ball_put_on_centre()
  ball.rds = 0
  ball.x = 1+ PITCH_MIDDLE_W
  ball.y = 1+ PITCH_MIDDLE_H
  ball.z = 0
  ball.z_speed = 0
  ball.speed = 0
  ball.w = 4
  ball.frame = 0
End Sub

Sub reset_players_positions()
  Dim c As Integer
  For c = 0 To (PL_N_TOT*2-1)
    Select Case c
      'goalkeepers
      Case 0, 1
        If c = 0 Then
          pl(c).x = PITCH_MIDDLE_W
          pl(c).y = PITCH_Y + 25+((PITCH_H-50) * (pl(c).team Xor 1))
        Else
          pl(c).x = PITCH_MIDDLE_W
          pl(c).y = PITCH_Y + 25+((PITCH_H-50) * (pl(c).team Xor 1))
        End If
        'other players
      Case Else
        If c Mod 2 = 0 Then
          pl(c).x = Rnd * PITCH_W + PITCH_X
          pl(c).y = Rnd * PITCH_H\2 + PITCH_Y + PITCH_H\2

        Else
          pl(c).x = Rnd * PITCH_W + PITCH_X
          pl(c).y = Rnd * PITCH_H\2 + PITCH_Y
        End If
    End Select
    pl(c).active = 1
    pl(c).action = 1
  Next c
End Sub

Sub draw_players()
  Dim As Integer b, c, lowest, start, change
  Dim As Integer ref
  Dim a(PL_N_TOT * 2,2) As Integer

  b = 0

  'z sorting by pl.y value - using selection sorting algorithm

  For c = 0 To PL_N_TOT * 2-1
    a(c,0) = c
    a(c,1) = pl(c).y
  Next c

  For start = 0 To PL_N_TOT * 2 - 1
    ref = a(start,1)
    change = 0
    For b = start+1 To PL_N_TOT * 2 - 1
      If a(b,1) < ref Then
        ref = a(b, 1)
        lowest = b
        change = 1
      End If
    Next b
    If change Then
      Swap a(lowest, 0), a(start, 0)
      Swap a(lowest, 1), a(start, 1)
    End If
  Next start

  'draws players, shadow, and circle under nearest pl to the ball
  For c = 0 To PL_N_TOT * 2 - 1
    'draws circles yellow or red under the nearest pl to the ball
    If (Human_control) Then
      If get_nrst_pl_ball(pl(a(c,0)).team) = a(c,0) Then
        If pl(a(c,0)).team = 0 Then
          'another one ring if the pl is the ball owner
          If a(c,0) = PL_ball_owner_id Then
            Circle (pl(a(c,0)).x - c_x_o, pl(a(c,0)).y+9 - c_y_o),11, C_WHITE,,,,F
          End If
          Circle (pl(a(c,0)).x - c_x_o, pl(a(c,0)).y+9 - c_y_o),9, RGB(200,0,100),,,,F
          Circle (pl(a(c,0)).x - c_x_o, pl(a(c,0)).y+9 - c_y_o),6, RGB(0,50,0),,,,F
        End If
        'draw the pl number
        'draw string (pl(a(c,0)).x -6- c_x_o, pl(a(c,0)).y -30  - c_y_o), str(int(abs( PITCH_Y + PITCH_H * (pl(a(c,0)).team xor 0) - pl(a(c,0)).y)))'str(pl(a(c,0)).number)
      End If
    End If
    If (DEBUG) Then
      Draw String (pl(a(c,0)).x -6- c_x_o, pl(a(c,0)).y -60  - c_y_o), Str(pl(a(c,0)).action)    'DEBUG
      Draw String (pl(a(c,0)).x -6- c_x_o, pl(a(c,0)).y -45  - c_y_o), Str(pl(a(c,0)).active)    'DEBUG
      Draw String (pl(a(c,0)).x -6- c_x_o, pl(a(c,0)).y -45  - c_y_o), Str(pl(a(c,0)).delay)    'DEBUG
    End If
    'puts the right set of sprites depending on the pl.action
    If is_in_camera_crop (pl(a(c,0)).x, pl(a(c,0)).y, 128) Then

      Select Case pl(a(c,0)).action
        Case 0 '*** at this moment undefined***
        Case 1 'RUNNING############################################################
          pl(a(c,0)).frame_offset = 0
          pl(a(c,0)).dist += pl(a(c,0)).speed /7
          If pl(a(c,0)).dist > 1 Then
            pl(a(c,0)).frame += 1
            pl(a(c,0)).dist = 0
          End If
          If pl(a(c,0)).speed = 0 Then pl((a(c,0))).frame = 0
          If pl(a(c,0)).frame > 5 Then pl(a(c,0)).frame=1
          If pl(a(c,0)).team = 0 Then
            If pl(a(c,0)).id < 2 Then
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              gk_sprite(start_frame(pl(a(c,0)).rds)+pl(a(c,0)).frame), Trans
            Else
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              pl_sprite_0(start_frame(pl(a(c,0)).rds)+pl(a(c,0)).frame), Trans
            End If
          Else
            If pl(a(c,0)).id < 2 Then
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              gk_sprite(start_frame(pl(a(c,0)).rds)+pl(a(c,0)).frame), Trans
            Else
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              pl_sprite_1(start_frame(pl(a(c,0)).rds)+pl(a(c,0)).frame), Trans
            End If
          End If
        Case 2 'JUMPING for HEADKICKS#############################
          If pl(a(c,0)).team = 0 Then
            If pl(a(c,0)).id < 2 Then
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              gk_sprite(start_frame(pl(a(c,0)).rds)+13), Trans
            Else
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              pl_sprite_0(start_frame(pl(a(c,0)).rds)+13), Trans
            End If
          Else
            If pl(a(c,0)).id < 2 Then
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              gk_sprite(start_frame(pl(a(c,0)).rds)+13), Trans
            Else
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              pl_sprite_1(start_frame(pl(a(c,0)).rds)+13), Trans
            End If
          End If
        Case 3 'SLIDING ###########################################################
          If pl(a(c,0)).team = 0 Then
            If pl(a(c,0)).id < 2 Then
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              gk_sprite(start_frame(pl(a(c,0)).rds)+12), Trans
            Else
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              pl_sprite_0(start_frame(pl(a(c,0)).rds)+12), Trans
            End If
          Else
            If pl(a(c,0)).id < 2 Then
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              gk_sprite(start_frame(pl(a(c,0)).rds)+12), Trans
            Else
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              pl_sprite_1(start_frame(pl(a(c,0)).rds)+12), Trans
            End If
          End If
        Case 4 'FALLING ###########################################################
          pl(a(c,0)).frame_offset +=1
          If pl(a(c,0)).frame_offset > 9 Then pl(a(c,0)).frame_offset = 0
          If pl(a(c,0)).team = 0 Then
            If pl(a(c,0)).id < 2 Then
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              gk_sprite(start_frame(pl(a(c,0)).rds)+Int(pl(a(c,0)).frame_offset/2)+6), Trans
            Else
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              pl_sprite_0(start_frame(pl(a(c,0)).rds)+Int(pl(a(c,0)).frame_offset/2)+6), Trans
            End If
          Else
            If pl(a(c,0)).id < 2 Then
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              gk_sprite(start_frame(pl(a(c,0)).rds)+Int(pl(a(c,0)).frame_offset/2)+6), Trans
            Else
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              pl_sprite_1(start_frame(pl(a(c,0)).rds)+Int(pl(a(c,0)).frame_offset/2)+6), Trans
            End If
          End If
        Case 5
          If pl(a(c,0)).team = 0 Then
            If pl(a(c,0)).id < 2 Then
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              gk_sprite(start_frame(pl(a(c,0)).rds)+6), Trans
            Else
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              pl_sprite_0(start_frame(pl(a(c,0)).rds)+6), Trans
            End If
          Else
            If pl(a(c,0)).id < 2 Then
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              gk_sprite(start_frame(pl(a(c,0)).rds)+6), Trans
            Else
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              pl_sprite_1(start_frame(pl(a(c,0)).rds)+6), Trans
            End If
          End If
        Case 6 'Goalkeeping jump
          pl(a(c,0)).frame_offset +=1
          If pl(a(c,0)).frame_offset > 12 Then pl(a(c,0)).frame_offset = 0
          If pl(a(c,0)).team = 0 Then
            If pl(a(c,0)).id < 2 Then
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              gk_sprite(start_frame(pl(a(c,0)).rds)+Int(pl(a(c,0)).frame_offset/2)+14), Trans
            Else
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              pl_sprite_0(start_frame(pl(a(c,0)).rds)+Int(pl(a(c,0)).frame_offset/2)+14), Trans
            End If
          Else
            If pl(a(c,0)).id < 2 Then
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              gk_sprite(start_frame(pl(a(c,0)).rds)+Int(pl(a(c,0)).frame_offset/2)+14), Trans
            Else
              Put (pl(a(c,0)).x - pl(a(c,0)).w - c_x_o, pl(a(c,0)).y - pl(a(c,0)).w - c_y_o),_
              pl_sprite_1(start_frame(pl(a(c,0)).rds)+Int(pl(a(c,0)).frame_offset/2)+14), Trans
            End If
          End If
        Case Else

      End Select
    End If
  Next c

End Sub

Sub update_players()
  Dim c As Integer
  Dim decision As Integer
  Dim pl_to_pass As Integer
  Dim trg_x As Single
  Dim trg_y As Single

  'the following is a very bad try to give a decent AI to the players
  For c = 0 To PL_N_TOT * 2 - 1
    'this is useful for the pl behaviour
    decision = Rnd*100
    'this is useful for the sprites
    pl(c).old_x = pl(c).x
    pl(c).old_y = pl(c).y

    Select Case pl(c).action
      Case 0
      Case 1 '#### RUNNING ##########################################################
        'countdown of the delay
        If pl(c).delay > 1 Then
          pl(c).delay -=1
        Else
          pl(c).delay = 0
        End If
        'goalkeepers routine
        If c < 2 Then
          'PITCH_X + 25 +((PITCH_W - 50) * (pl(c).team xor 0))

          trg_x = PITCH_MIDDLE_W
          trg_y = PITCH_Y + 25+((PITCH_H-50) * (pl(c).team Xor 1))
          ' if the ball is into the area then the GK runs to the ball
          If d_b_t_p(trg_x, trg_y, ball.x, ball.y) < PITCH_PENALTY_AREA -25 Then
            pl(c).rds = a_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y)
            pl(c).speed = 5
            ' if the ball is VERY near, and is in posses of the opponent team
            ' try to catch the ball jumping on it
            If d_b_t_p(pl(c).x,pl(c).y, ball.x, ball.y) < 30 And _
              ball.z < 25 And PL_team_owner_id <> pl(c).team Then
              pl(c).speed = 5 + Int(Rnd*10)
              pl(c).action = 6
              pl(c).delay = 12
              Exit Select
            End If
            ' if the ball is VERY near... kick away the ball
            If d_b_t_p(pl(c).x,pl(c).y, ball.x, ball.y) < 5 And _
              ball.z < 15 And PL_team_owner_id = pl(c).team And get_nrst_pl_ball(pl(c).team)Then
              ball.speed = Rnd*15 + 5
              ball.rds = a_b_t_p (pl(c).x, pl(c).y,_
              PITCH_X + (PITCH_W * (pl(c).team Xor 1)), PITCH_MIDDLE_H)_
              + Rnd * .5 -.25
              ball.z_speed += 10
              ball.z_speed_init = 15
              PL_team_owner_id = pl(c).team
              PL_ball_owner_id = pl(c).id
            End If

            'else return to the net
          Else
            'keep running to the net until the distance is more than 5
            If d_b_t_p(pl(c).x, pl(c).y, trg_x, trg_y) > 5 Then
              pl(c).rds = a_b_t_p(pl(c).x,pl(c).y, trg_x, trg_y)
              pl(c).speed = 3
              'when get the net stay there
            Else
              pl(c).speed = 0
              pl(c).x = trg_x
              pl(c).y = trg_y
              'when stay in the net always watch the ball
              pl(c).rds = a_b_t_p(pl(c).x,pl(c).y, ball.x, ball.y)
            End If
          End If
        Else
          'routine for other players (defenders, midfielders, attackers)#########
          'if the pl(c) is the nearest to the ball
          'run to the ball and restore original speed of the player

          If get_nrst_pl_ball(pl(c).team) = c Then
            If Human_control Then
              If pl(c).team = 0 Then
                pl(c).speed = 0
                get_user_input_ways(c)
                If is_ball_controllable_by_human(c) Then
                  reset_ball_z()
                  'if this is the first touch then centre the ball on the player
                  If PL_ball_owner_id <> c Then
                    ball.x = pl(c).x
                    ball.y = pl(c).y
                    ball.x +=  Cos(pl(c).rds)*pl(c).speed*0.35f
                    ball.y +=  -Sin(pl(c).rds)*pl(c).speed*0.35f
                  End If
                  ball.rds = pl(c).rds
                  ball.speed = pl(c).speed + Rnd*1.5
                  PL_ball_owner_id = c
                  PL_team_owner_id = pl(c).team

                  get_user_input_action(c)
                End If
                Exit Select
              End If
            End If
            pl(c).speed = pl(c).speed_default
            pl(c).rds =  a_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y)

            ' try to catch the ball with SLIDING###############################
            If (decision > 90 And is_ball_slidable(c)) Then
              pl(c).speed = 15
              pl(c).delay =  20
              pl(c).action = 3 '3 = sliding
              Continue For
            End If
            'try to hit the ball with HEADKICK################################
            If (decision > 80 And is_ball_headkickable(c)) Then
              pl(c).speed = 12
              pl(c).delay = 10
              pl(c).action = 2 '2 = headkicking
              Continue For
            End If
            'if the ball is very near and at the same z level of the pl the
            'pl became owner of the ball
            '#PLAYER OWNER OF THE BALL#

            If d_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y) < 6 And ball.z < 4 Then
              ' if there is enough room - run to the opponent net
              If d_b_t_p (pl(c).x,pl(c).y,_
                pl(get_nrst_pl_ball(pl(c).team Xor 1)).x,_
                pl(get_nrst_pl_ball(pl(c).team Xor 1)).y) > PL_RUN_SPACE Then
                reset_ball_z()
                ball.rds = a_b_t_p (pl(c).x, pl(c).y,_
                PITCH_MIDDLE_W, PITCH_Y + (PITCH_H * (pl(c).team Xor 0))) + Rnd * .5 -.25
                ball.speed = pl(c).speed + Rnd*2 + 1
                PL_target_id = -1 ' The pl is not passing to anyone
                PL_ball_owner_id = c ' The pl become the ball owner

                SHELL_message = "run to opponent"
              Else
                'get the pl behaviour
                get_pl_behavior(c)
              End If
              Continue For
            End If
            'else follow the tactics
          Else
            ' if the pl owns the id that is receiving the ball, him runs to the
            'ball with a little speed help
            If c = PL_target_id Then
              pl(c).rds = a_b_t_p(pl(c).x,pl(c).y, ball.x, ball.y)
              pl(c).speed = pl(c).speed_default * 1.2
            Else
              'else runs the tactic
              run_tactic(c)
            End If
          End If
        End If
      Case 2 'HEADKICKING#####################################################################
        pl(c).speed *= 0.85f 'friction of the pl body with the air
        pl(c).delay -= 1
        'if the delay time has passed
        If pl(c).delay < 1 Then
          pl(c).action = 1
          'maybe the pl after the headkick will fall
          If (Int(Rnd*10)> 5) Then
            pl(c).action = 5
            pl(c).active = 0
            'pl(c).delay = PL_DELAY_FALLED
          End If
          pl(c).delay = PL_DELAY_FALLED
        End If
        'Oh yeah, I can headkicking, the ball is so near!
        If (d_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y) < 20 And ball.z < 20 And ball.z > 6) Then
          ball.rds = pl(c).rds + (PI/2 - PI/4)
          ball.speed = pl(c).speed + Rnd * 5 + 5
          If (Int(Rnd*10)> 5) Then
            ball.z_speed_init = 10
            ball.z_speed=ball.z_speed_init
          End If
          PL_ball_owner_id = c
          pl(c).speed = pl(c).speed_default
        End If
      Case 3 'SLIDING#####################################################################
        pl(c).speed *= 0.80f 'friction of the pl body with the grass
        pl(c).delay -= 1
        'if the delay time has passed or the pl has catched the ball
        If pl(c).delay < 1 Or _
          (d_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y) < 6 And ball.z < 4) Then
          pl(c).action = 1
          pl(c).delay = PL_DELAY_FALLED
          pl(c).speed = pl(c).speed_default
        End If
      Case 4 'falling ... delays and goto falled
        pl(c).speed *= 0.1f
        pl(c).delay -= 1
        If pl(c).delay < 1 Then
          pl(c).action = 5
          pl(c).delay = PL_DELAY_FALLED
        End If
      Case 5 'falled
        pl(c).delay -= 1
        pl(c).speed = 0
        If pl(c).delay < 1 Then
          pl(c).active = 1
          pl(c).action = 1
          pl(c).delay = PL_DELAY_FALLED
          pl(c).speed = pl(c).speed_default
        End If
      Case 6 'Only for GoalKeeper - Jumping to catch the ball
        pl(c).speed *= 0.75f 'friction of the pl body with the air
        pl(c).delay -= 1
        'if the gk can catch the ball
        If d_b_t_p(pl(c).x,pl(c).y, ball.x, ball.y) < 30 And ball.z < 25 And pl(c).active = 1 Then
          ball.speed *= 0.55f
          ball.z_speed *= 0.8f
          ball.z_speed_init = ball.z_speed
          ball.rds = PI*2 - ball.rds
          PL_target_id = -1 ' The GK is not passing to anyone
          PL_ball_owner_id = c ' The pl become the ball owner
          PL_team_owner_id = pl(c).team 'his team is the ball owner
          pl(c).active = 0
        End If
        If pl(c).delay < 1 Then
          pl(c).action = 5
          pl(c).delay = 5
          pl(c).speed = pl(c).speed_default
        End If
      Case Else
    End Select
    'pl limit check, don't go outside the PITCH
    If pl(c).x > PITCH_W + PITCH_X Then pl(c).rds = a_b_t_p(pl(c).x, pl(c).y,PITCH_MIDDLE_W,PITCH_MIDDLE_H)
    If pl(c).x < PITCH_X Then pl(c).rds = a_b_t_p(pl(c).x, pl(c).y,PITCH_MIDDLE_W,PITCH_MIDDLE_H)
    If pl(c).y > PITCH_H + PITCH_Y Then pl(c).rds = a_b_t_p(pl(c).x, pl(c).y,PITCH_MIDDLE_W,PITCH_MIDDLE_H)
    If pl(c).y < PITCH_Y Then pl(c).rds = a_b_t_p(pl(c).x, pl(c).y,PITCH_MIDDLE_W,PITCH_MIDDLE_H)

    '###IMPORTANT!#####
    'update pl position moving him
    pl(c).x +=  Cos(pl(c).rds)*pl(c).speed
    pl(c).y +=  -Sin(pl(c).rds)*pl(c).speed
  Next c
End Sub

Sub camera_update_position()
  camera.speed = d_b_t_p(camera.x, camera.y, ball.x, ball.y) / CAMERA_EASING_RATIO
  camera.x += Cos(a_b_t_p(camera.x, camera.y, ball.x, ball.y))*camera.speed
  camera.y += -Sin(a_b_t_p(camera.x, camera.y, ball.x, ball.y))*camera.speed

  'padding & border limit check
  If (camera.x < PITCH_X + camera.w/2 - CAMERA_PADDING) Then
    camera.x = PITCH_X + camera.w/2 - CAMERA_PADDING
  End If
  If (camera.x > PITCH_X + PITCH_W - camera.w/2 + CAMERA_PADDING) Then
    camera.x = PITCH_X + PITCH_W - camera.w/2 + CAMERA_PADDING
  End If
  If (camera.y > PITCH_Y + PITCH_H - camera.h/2 + CAMERA_PADDING) Then
    camera.y = PITCH_Y + PITCH_H - camera.h/2 + CAMERA_PADDING
  End If
  If (camera.y < PITCH_Y + camera.h/2 - CAMERA_PADDING) Then
    camera.y = PITCH_Y + camera.h/2 - CAMERA_PADDING
  End If
  'update global variables
  c_x_o = camera.x - camera.w/2
  c_y_o = camera.y - camera.h/2
End Sub

Sub init_players_proprietes()
  'initializing players proprietes
  Dim c As Integer
  For c = 0 To (PL_N_TOT*2-1)
    Select Case c
      'goalkeepers
      Case 0, 1
        If c = 0 Then
          pl(c).id = c
          pl(c).team = 0
          pl(c).number = Int (c / 2)+1
          pl(c).x = PITCH_MIDDLE_W
          pl(c).y = PITCH_Y + 25+((PITCH_H-50) * (pl(c).team Xor 1))

          pl(c).speed_default = 0
          pl(c).speed = pl(c).speed_default
        Else
          pl(c).id = c
          pl(c).team = 1
          pl(c).number = Int (c / 2)+1
          pl(c).x = PITCH_MIDDLE_W
          pl(c).y = PITCH_Y + 25+((PITCH_H-50) * (pl(c).team Xor 1))

          pl(c).speed_default = 0
          pl(c).speed = pl(c).speed_default
        End If
        pl(c).frame = 0

        pl(c).tact_offset_x = Rnd * 60 - 30
        pl(c).tact_offset_y = Rnd * 60 - 30
        pl(c).ball_radius = 25
        pl(c).w = 10
        pl(c).delay = PL_DELAY_TIME
        pl(c).active = 1 ' by default the pl is ready to perform any action
        pl(c).action = 1 'by default the pl can run
        'other players
      Case Else
        If c Mod 2 = 0 Then
          pl(c).id = c
          pl(c).team = 0
          pl(c).number = Int (c / 2)+1
          pl(c).x = Rnd * PITCH_W + PITCH_X
          pl(c).y = Rnd * PITCH_H\2 + PITCH_Y + PITCH_H\2

        Else
          pl(c).id = c
          pl(c).team = 1
          pl(c).number = Int (c / 2)+1
          pl(c).x = Rnd * PITCH_W + PITCH_X
          pl(c).y = Rnd * PITCH_H\2 + PITCH_Y

        End If
        pl(c).rds = 0
        pl(c).frame = 0
        pl(c).frame_offset = 0
        pl(c).dist = 0
        pl(c).speed_default = Rnd*(PL_DEFAULT_SPEED*2) + PL_DEFAULT_SPEED*2
        pl(c).speed = pl(c).speed_default
        pl(c).tact_offset_x = Rnd * 60 - 30
        pl(c).tact_offset_y = Rnd * 60 - 30
        pl(c).ball_radius = 25
        pl(c).w = 10
        pl(c).delay = PL_DELAY_TIME
        pl(c).active = 1 ' by default the pl is ready to perform any action
        pl(c).action = 1 'by default the pl can run
    End Select
  Next c
  'initialize who is receiving the ball (none)
  PL_target_id = -1
End Sub

Sub draw_top_net()
  Put (PITCH_MIDDLE_W - 53 - c_x_o, PITCH_Y - 38 - c_y_o ), net_sprite(0), Trans
End Sub

Sub draw_bottom_net()
  Put (PITCH_MIDDLE_W - 53 - c_x_o, PITCH_Y + PITCH_H - 28 - c_y_o ), net_sprite(1), Trans
End Sub

Sub load_tact()
  'the "tct_tile" array indicates in wich tile the player must be with corresponding
  'ball position. For example: ball in tile 0 -> read from tct_tile(0) = player in tile 1
  Dim tl As Integer
  Dim c As Integer

  For c = 0 To 9
    For tl = 0 To 35
      Read tct_tile(c,tl)
    Next tl
  Next c
End Sub

'TACT DATA
'each row represents in wich tile the pl must go when he doesn't own the ball
'So, the defender (id: 1) must go to these tiles:
'DATA 	1,1,2,2,2,2,7,7,2,2 [...] etc
' when the ball is in the tile 0, he must go to tile 1
' when the ball is in the tile 1, he must go to tile 1
' when the ball is in the tile 2, he must go to tile 2 [...] and so on...

Data    1,1,1,1,1,1,1,1,1,1,1,1,7,7,7,7,7,7,7,7,7,7,7,7,13,13,13,13,13,13,13,13,13,13,13,13
Data    2,2,2,2,2,2,2,2,2,2,2,2,8,8,8,8,8,8,8,8,8,8,8,8,14,14,14,14,14,14,14,14,14,14,14,14
Data    3,3,3,3,3,3,3,3,3,3,3,3,9,9,9,9,9,9,9,9,9,9,9,9,9,15,15,15,15,15,15,15,15,15,15,15
Data    4,4,4,4,4,4,4,4,4,4,4,4,10,10,10,10,10,10,10,10,10,10,10,10,16,16,16,16,16,16,16,16,16,16,16,16
Data    12,13,13,13,13,13,12,13,13,13,13,13,13,13,13,13,13,13,19,19,19,19,19,19,19,19,19,25,25,25,30,25,25,25,25,25
Data    14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,14,20,20,20,20,20,20,26,26,26,26,26,26,25,26,26,26,26,26
Data    15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,15,21,21,21,21,21,21,27,27,27,27,27,27,27,27,27,27,27,28
Data    17,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,16,22,22,22,22,22,22,22,22,22,22,28,28,28,28,28,28,28,35
Data    20,20,20,20,20,20,20,20,20,20,20,20,26,26,26,26,26,26,26,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32,32
Data    21,21,21,21,21,21,21,21,21,21,21,21,27,27,27,27,27,27,27,33,33,33,33,28,33,33,33,33,33,33,33,33,33,33,33,33

'see comment below for details about the bhv_tile array
Sub load_behavior()
  Dim tl As Integer
  Dim c As Integer
  Dim temp As Integer
  'read and store into array
  For tl = 0 To 35
    For c = 0 To 9
      Read bhv_tile(tl,c)
    Next c
  Next tl
  'transform 10, 20, 35 -> 10, (20+10) = 30, (10+20+35) = 65 [...] and so on
  For tl = 0 To 35
    For c = 1 To 9
      temp = bhv_tile(tl,c-1)
      bhv_tile(tl,c) += temp
    Next c
  Next tl

End Sub
'BEHAVIOR DATA
'each row represents the behavior of the player OWNER of the ball in "x" tile
'every column represents a percentage [...]
'So, if the pl owns the ball in the 0 tile he could:
'DATA    [tile 0] 10,20,10,20,4,4,10,4,18,0
' 10% pass to nearest, 20% pass to 2nd nearest, 10% pass by short side,
'20% pass longside, 4% pass to the endline pl [...] and so on...

'fields meaning:
'0: pass_to_nearest; 1: pass_to_2nd_nearest; 2: pass_short_side; 3: pass_long_side
'4:pass_endline; 5: pass_center; 6: run_to_centre; 7: run_to_net
'8: run_to_endline; 9: shoot_in_target
'(see functions meaning on the top of this file)
'IMPORTANT: the SUM of each row is always 100

Data    10,20,10,20,4,4,10,4,18,0
Data    5,10,5,27,4,4,15,10,20,0
Data    4,12,3,35,8,13,10,5,10,0
Data    4,12,3,35,8,13,10,5,10,0
Data    5,10,5,27,4,4,15,10,20,0
Data    10,20,10,20,4,4,10,4,18,0
Data    7,10,7,25,5,15,10,3,18,0
Data    5,12,7,21,6,18,13,3,15,0
Data    2,7,10,22,7,21,13,3,15,0
Data    2,7,10,22,7,21,13,3,15,0
Data    5,12,7,21,6,18,13,3,15,0
Data    7,10,7,25,5,15,10,3,18,0
Data    8,9,8,13,15,13,14,8,12,0
Data    7,8,9,12,16,18,10,9,11,0
Data    7,11,11,14,14,7,7,14,15,0
Data    7,11,11,14,14,7,7,14,15,0
Data    7,8,9,12,16,18,10,9,11,0
Data    8,9,8,13,15,13,14,8,12,0
Data    5,10,7,15,20,6,6,13,13,5
Data    4,9,10,18,20,6,5,12,10,6
Data    3,10,9,15,25,3,2,13,12,8
Data    3,10,9,15,25,3,2,13,12,8
Data    4,9,10,18,20,6,5,12,10,6
Data    5,10,7,15,20,6,6,13,13,5
Data    10,10,7,7,15,2,7,16,15,11
Data    10,10,10,5,18,3,8,10,10,16
Data    8,8,12,12,17,0,3,10,10,20
Data    8,8,12,12,17,0,3,10,10,20
Data    10,10,10,5,18,3,8,10,10,16
Data    10,10,7,7,15,2,7,16,15,11
Data    5,7,15,5,25,8,7,13,3,12
Data    3,4,4,2,21,2,6,22,1,35
Data    2,2,2,2,20,6,4,16,1,45
Data    2,2,2,2,20,6,4,16,1,45
Data    3,4,4,2,21,2,6,22,1,35
Data    5,7,15,5,25,8,7,13,3,12

Sub get_pl_behavior(pl_id As Integer)
  Dim tile As Integer '0-35
  Dim decision As Integer '0-100
  Dim pl_to_pass As Integer

  decision = Rnd*101
  tile = get_ball_tile(pl(pl_id).team)

  Select Case decision
    Case 0 To bhv_tile(tile, 0) '0: PASS TO NEAREST
      SHELL_message =  Str(decision) + " TILE " + Str(tile) + " PASS to nearest"
      'setting ball proprietes (z, angle, speed)
      reset_ball_z()
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,pl(get_nrst_pl_pass(pl_id)).x,pl(get_nrst_pl_pass(pl_id)).y)+Rnd*.3f-0.15f
      ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
      pl(get_nrst_pl_pass(pl_id)).x,pl(get_nrst_pl_pass(pl_id)).y))

      PL_target_id = get_nrst_pl_pass(pl_id)
      PL_ball_owner_id = pl_id
      PL_team_owner_id = pl(pl_id).team

      Exit Sub
    Case bhv_tile(tile, 0)+1 To bhv_tile(tile, 1)'1: pass_to_2nd_nearest
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " PASS 2nd nearest"
      pl_to_pass = Rnd*2 + 1

      'setting ball proprietes (z, angle, speed)
      reset_ball_z()
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      pl(get_nrst2_pl_pass(pl_id, pl_to_pass)).x,pl(get_nrst2_pl_pass(pl_id,pl_to_pass)).y)+Rnd*.3f-0.15f
      ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
      pl(get_nrst2_pl_pass(pl_id, pl_to_pass)).x,pl(get_nrst2_pl_pass(pl_id,pl_to_pass)).y))

      PL_target_id = get_nrst2_pl_pass(pl_id,pl_to_pass)
      PL_ball_owner_id = pl_id
      PL_team_owner_id = pl(pl_id).team
      Exit Sub
    Case bhv_tile(tile, 1)+1 To bhv_tile(tile, 2)'2: pass_short_side
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " PASS Short Side"

      'setting ball proprietes (z, angle, speed)
      reset_ball_z()
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,pl(get_shortside_pl_to_pass(pl_id)).x,pl(get_shortside_pl_to_pass(pl_id)).y)+Rnd*.3f-0.15f
      ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
      pl(get_shortside_pl_to_pass(pl_id)).x,pl(get_shortside_pl_to_pass(pl_id)).y))

      PL_target_id = get_shortside_pl_to_pass(pl_id)
      PL_ball_owner_id = pl_id
      PL_team_owner_id = pl(pl_id).team

      Exit Sub
    Case bhv_tile(tile, 2)+1 To bhv_tile(tile, 3)'3: pass_long_side
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " PASS Long Side"

      reset_ball_z()
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      pl(get_longside_pl_to_pass(pl_id)).x,pl(get_longside_pl_to_pass(pl_id)).y)
      ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
      pl(get_longside_pl_to_pass(pl_id)).x,pl(get_longside_pl_to_pass(pl_id)).y))

      PL_target_id = get_longside_pl_to_pass(pl_id)
      PL_ball_owner_id = pl_id
      PL_team_owner_id = pl(pl_id).team
      Exit Sub
    Case bhv_tile(tile, 3)+1 To bhv_tile(tile, 4)'4: pass_endline
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " PASS Endline"

      'setting ball proprietes (z, angle, speed)

      If decision Mod 2 = 0 Then
        reset_ball_z()
        ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
        pl(get_endline_pl_to_pass(pl_id)).x,pl(get_endline_pl_to_pass(pl_id)).y))
      Else
        ball.z_speed_init = Rnd*5+10
        ball.z_speed=ball.z_speed_init
        ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
        pl(get_endline_pl_to_pass(pl_id)).x,pl(get_endline_pl_to_pass(pl_id)).y)) /5
      End If
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      pl(get_endline_pl_to_pass(pl_id)).x,pl(get_endline_pl_to_pass(pl_id)).y)

      PL_target_id = get_endline_pl_to_pass(pl_id)
      PL_ball_owner_id = pl_id
      PL_team_owner_id = pl(pl_id).team
      Exit Sub
    Case bhv_tile(tile, 4)+1 To bhv_tile(tile, 5)'5: pass_center
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " PASS center"

      reset_ball_z()
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      pl(get_centerest_pl_to_pass(pl_id)).x,pl(get_centerest_pl_to_pass(pl_id)).y)
      ball.speed = get_passing_ball_speed (d_b_t_p(pl(pl_id).x, pl(pl_id).y,_
      pl(get_centerest_pl_to_pass(pl_id)).x,pl(get_centerest_pl_to_pass(pl_id)).y))

      PL_target_id = get_centerest_pl_to_pass(pl_id)
      PL_ball_owner_id = pl_id
      PL_team_owner_id = pl(pl_id).team
      Exit Sub
    Case bhv_tile(tile, 5)+1 To bhv_tile(tile, 6)'6: run_to_centre
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " R U N centre"
      ball.speed = pl(pl_id).speed + Rnd*5 + 1
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y, pl(pl_id).x, PITCH_MIDDLE_H) + Rnd * .5 -.25
      PL_target_id = -1 ' The pl is not passing to anyone
      PL_ball_owner_id = pl_id ' The pl become the ball owner
      Exit Sub
    Case bhv_tile(tile, 6)+1 To bhv_tile(tile, 7)'7: run_to_net
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " R U N to net"

      reset_ball_z()

      ' 1 xor 1 = 0 so 0*PITCH_W = 0 else 1*PITCH_W = PITCH_W
      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      PITCH_MIDDLE_W , (PITCH_Y + PITCH_H * (pl(pl_id).team Xor 1))) + Rnd * .5 -.25
      ball.speed = pl(pl_id).speed + Rnd*5 + 1
      PL_target_id = -1 ' The pl is not passing to anyone
      PL_ball_owner_id = pl_id ' The pl become the ball owner
      PL_team_owner_id = pl(pl_id).team
      Exit Sub
    Case bhv_tile(tile, 7)+1 To bhv_tile(tile, 8)'8: run_to_endline
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " R U N to endline"

      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      PITCH_X + (PITCH_W * (pl(pl_id).team Xor 1)), pl(pl_id).y+1) + Rnd * .5 -.25
      ball.speed = pl(pl_id).speed + Rnd*5 + 1
      PL_target_id = -1 ' The pl is not passing to anyone
      PL_ball_owner_id = pl_id ' The pl become the ball owner
      PL_team_owner_id = pl(pl_id).team
      'debug

      Exit Sub
    Case bhv_tile(tile, 8)+1 To 100             '9: shoot_in_target
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " SHOOT in TARGET"

      ball.rds = a_b_t_p (pl(pl_id).x, pl(pl_id).y,_
      PITCH_MIDDLE_W , PITCH_Y + PITCH_H * (pl(pl_id).team Xor 0)) + Rnd * .5 -.25

      If decision Mod 2 = 0 Then
        ball.speed = 5*Rnd+10
        ball.z_speed_init = Rnd*5+9
        ball.z_speed=ball.z_speed_init
      Else
        reset_ball_z()
        ball.speed = 2*Rnd+18
        ball.z_speed_init = 10
        ball.z_speed=ball.z_speed_init
      End If


      PL_target_id = -1 ' The pl is not passing to anyone
      PL_ball_owner_id = pl_id ' The pl become the ball owner
      PL_team_owner_id = pl(pl_id).team
      Exit Sub
    Case Else
      SHELL_message =  Str(decision) + " - TILE " + Str(tile) + " *** SORRY <undefined>"
      Exit Sub

  End Select
End Sub

Sub reset_ball_z()
  ball.z = 0
  ball.z_speed = 0
  ball.z_speed_init = 0
End Sub

Sub check_pl_collisions()
  Dim c As Integer
  Dim d As Integer
  'check each pl
  For c = 0 To (PL_N_TOT*2-1)
    'check collision only if the interested pllayers are int the crop view
    If is_in_camera_crop (pl(c).x, pl(c).y, 64) Then
      For d  = 0 To (PL_N_TOT*2-1)
        If d = c Or pl(d).active = 0 Then Continue For 'doesn't check himself obviously :)
        If d_b_t_p (pl(c).x, pl(c).y,pl(d).x, pl(d).y) < PL_MIN_DIST Then
          'some fighting betweeen two players
          pl(d).x = pl(d).old_x + PL_MIN_DIST/2 - (Rnd*PL_MIN_DIST)
          pl(d).y = pl(d).old_y + PL_MIN_DIST/2 - (Rnd*PL_MIN_DIST)

          'one of the may fall if the d pl is sliding
          If Int(Rnd*10) > 4 And pl(d).action = 3 Then
            pl(c).active = 0
            pl(c).action = 4
            pl(c).delay = PL_DELAY_FALLING
            pl(d).action = 1
            Continue For, For
          End If
          'also with running fighting one of the pl may fall
          If Int(Rnd*10) > 9 Then
            pl(c).active = 0
            pl(c).action = 4
            pl(c).delay = PL_DELAY_FALLING
            Continue For, For
          End If
          Continue For, For
        End If
      Next d
    End If
  Next c
End Sub

Sub draw_bottom_info()
  Dim d As Integer

  For d = 0 To Int (SCREEN_W \ 32) +1
    Put (32*d, SCREEN_H-32), shadowed_sprite, Trans
  Next

  Draw String (20,SCREEN_H - 20), Str(goal_team_0) + "-" + Str(goal_team_1)
  Draw String (64,SCREEN_H - 20), SHELL_message, RGB(200,200,200)
  'Draw string (64,SCREEN_H - 50), str(PL_team_owner_id), RGB(200,200,200)
End Sub

Sub run_tactic(c As Integer)
  pl(c).speed = pl(c).speed_default
  pl(c).rds = get_rds_from_tile(get_tact_tile(c),pl(c).x + pl(c).tact_offset_x,pl(c).y+ pl(c).tact_offset_y)
  If get_dist_from_tile (get_tact_tile(c), pl(c).x + pl(c).tact_offset_x,pl(c).y + pl(c).tact_offset_y) < 5 Then
    pl(c).speed = 0
    'offset to the tactic to move randomly the the player (I don't like mummies)
    If Int(Rnd * 100) > 85 Then
      pl(c).tact_offset_x = Rnd * 30-15
      pl(c).tact_offset_y = Rnd * 30-15
    End If
  Else
    pl(c).speed = pl(c).speed_default
  End If
End Sub

Function d_t_r (degree As Integer) As Single
  Return Int (degree * PI/180)
End Function

Function r_t_d (radiants As Integer) As Integer
  Return Int ((radiants * 360) / (PI*2))
End Function

Function a_b_t_p (x1 As Single, y1 As Single, x2 As Single, y2 As Single) As Single
  If (x1>x2) Then
    If (y1>y2) Then
      Return Asin ((x1-x2)/Sqr(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2)))) + PI/2
    Else
      Return (2 * PI/4)*3 - Asin ((x1-x2)/Sqr(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2))))
    End If
  Else
    If (y1>y2) Then
      Return PI/2 - Asin ((x2-x1)/Sqr(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2))))
    Else
      Return (2 * PI/4)*3  - Asin ((x1-x2)/Sqr(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2))))
    End If
  End If
End Function

Function d_b_t_p (x1 As Single, y1 As Single, x2 As Single, y2 As Single) As Single
  Return Sqr(((x1-x2)*(x1-x2))+((y1-y2)*(y1-y2)))
End Function

Function start_frame (radiants As Single) As Integer
  Dim degree As Short
  'convert radiants to degree - not calling the function, it is much faster
  degree = Int((radiants * 360) / (2*PI))
  Select Case degree
    Case 0 To 22
      Return 0
    Case 23 To 67
      Return 21
    Case 68 To 112
      Return 42
    Case 113 To 157
      Return 63
    Case 158 To 202
      Return 84
    Case 203 To 247
      Return 105
    Case 248 To 292
      Return 126
    Case 292 To 337
      Return 147
    Case 337 To 360
      Return 0
    Case Else
      Return 14
  End Select
End Function

Function get_tact_tile (pl_id As Integer) As Integer
  '    'this routine find were the ball is and return the tile where the player must go
  Dim tile As Integer
  Dim number As Integer

  tile = tct_tile(pl(pl_id).number-2, get_ball_tile(pl(pl_id).team))

  If pl(pl_id).team = 0 Then
    Return tile
  Else
    Return TILES_N_TOT - tile
  End If
End Function

Function  get_rds_from_tile(tile As Integer, pl_x As Single, pl_y As Single) As Single
  Dim As Integer tile_row, tile_col, x_trg, y_trg

  tile_row = tile Mod COL_TOT_N
  tile_col = Int(tile\COL_TOT_N)

  x_trg = (tile_row * PITCH_W\ROW_TOT_N) + PITCH_X + (PITCH_W\ROW_TOT_N)\2
  y_trg = PITCH_H - (tile_col * PITCH_H\COL_TOT_N) + PITCH_Y - (PITCH_H\COL_TOT_N)\2

  'just to don't allow the player to disappear
  If x_trg > PITCH_X + PITCH_W Or y_trg > PITCH_Y + PITCH_H Then
    x_trg = PITCH_X + PITCH_W \2
    y_trg = PITCH_Y + PITCH_H \2
  End If

  Return a_b_t_p (pl_x,pl_y,x_trg,y_trg)
End Function

Function get_dist_from_tile(tile As Integer, pl_x As Single, pl_y As Single) As Single
  Dim As Integer tile_row, tile_col, x_trg, y_trg

  tile_col = tile Mod COL_TOT_N
  tile_row = Int(tile\COL_TOT_N)

  x_trg = (tile_col * PITCH_W\COL_TOT_N) + PITCH_X + (PITCH_W\COL_TOT_N)\2
  y_trg = PITCH_H - (tile_row * PITCH_H\ROW_TOT_N) + PITCH_Y - (PITCH_H\ROW_TOT_N)\2

  Return d_b_t_p (pl_x,pl_y,x_trg,y_trg)
End Function

Function get_nrst_pl_ball(n_team As Integer) As Integer
  Dim max_dist As Integer = 10000
  Dim c As Integer
  Dim id As Integer

  'start from id 2 or 3 to don't inlude goalkeepers
  If n_team = 0 Then
    For c = 2 To PL_N_TOT * 2-1 Step 2
      If d_b_t_p(pl(c).x,pl(c).y,ball.x,ball.y) < max_dist And pl(c).active = 1 Then
        max_dist = d_b_t_p(pl(c).x,pl(c).y,ball.x,ball.y)
        id = c
      End If
    Next c

    Return id
  Else
    For c = 3 To PL_N_TOT * 2-1 Step 2
      If d_b_t_p(pl(c).x,pl(c).y,ball.x,ball.y) < max_dist And pl(c).active = 1 Then
        max_dist = d_b_t_p(pl(c).x,pl(c).y,ball.x,ball.y)
        id = c
      End If
    Next c

    Return id
  End If
End Function

Function get_nrst_pl_pass(pl_id As Integer) As Integer
  Dim max_dist As Integer = 10000
  Dim As Integer c, id, n_team
  n_team = pl(pl_id).team
  'don't pass to goalkeeper
  For c = 2 To PL_N_TOT * 2-1
    If c = pl_id Or pl(c).team <> n_team Then Continue For 'don't pass himself ot to a player of the other team
    If d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y) < max_dist Then
      max_dist = d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y)
      id = c
    End If
  Next c
  Return id
End Function

Function get_longside_pl_to_pass (pl_id As Integer) As Integer

  Dim a(PL_N_TOT,2) As Integer
  Dim As Integer tile, c, id
  Dim max_dist As Integer = 10000
  'gets the ball's tile and search the nearest pl to pass who is in the horizontal next tile
  tile = get_ball_tile(pl(pl_id).team)
  If tile <=29 Then
    tile += COL_TOT_N
  End If

  If pl(pl_id).team <> 0 Then tile = TILES_N_TOT - tile

  For c = 0 To PL_N_TOT * 2-1
    If c = pl_id Or pl(c).team <> pl(pl_id).team Then Continue For 'don't pass himself or to a player of the other team
    If get_dist_from_tile(tile, pl(c).x, pl(c).y) < max_dist Then
      max_dist = get_dist_from_tile(tile, pl(c).x, pl(c).y)
      id = c
    End If
  Next c
  Return id
End Function

Function get_shortside_pl_to_pass (pl_id As Integer) As Integer

  Dim a(PL_N_TOT,2) As Integer
  Dim As Integer tile, c, id
  Dim max_dist As Integer = 10000
  '    'gets the ball's y and search the nearest pl to pass who is in the vert next tile
  '
  For c = 0 To PL_N_TOT * 2-1
    'don't pass himself or to a player of the other team
    If c = pl_id Or pl(c).team <> pl(pl_id).team Then Continue For
    If d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x+1,PITCH_MIDDLE_W) < max_dist Then
      max_dist = d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x+1,PITCH_MIDDLE_W)
      id = c
    End If
  Next c
  Return id
End Function

Function get_nrst2_pl_pass(pl_id As Integer, order As Integer) As Integer

  Dim a(PL_N_TOT,2) As Integer
  Dim As Integer b, c, lowest, start, change
  Dim As Integer ref
  'list all the pl's distances from the pl_id pl
  For c = 0 To PL_N_TOT * 2-1
    If c = pl_id Or pl(c).team <> pl(pl_id).team Then Continue For 'don't pass himself
    a(b,0)=c
    a(b,1)= d_b_t_p (pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y)

    b += 1
  Next c
  'sort'em using selection sorting algorithm
  For start = 0 To 9
    ref = a(start,1)
    change = 0
    For b = start+1 To 9
      If a(b,1) < ref Then
        ref = a(b, 1)
        lowest = b
        change = 1
      End If
    Next b
    If change Then
      Swap a(lowest, 0), a(start, 0)
      Swap a(lowest, 1), a(start, 1)
    End If
  Next start

  Return a(order, 0)
End Function

Function get_farrest_pl_to_pass(pl_id As Integer) As Integer
  Dim min_dist As Integer = 1
  Dim As Integer c, id, n_team
  n_team = pl(pl_id).team
  For c = 0 To PL_N_TOT * 2-1
    If c = pl_id Or pl(c).team <> n_team Then Continue For 'don't pass himself
    If d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y) > min_dist Then
      min_dist = d_b_t_p(pl(c).x,pl(c).y,pl(pl_id).x,pl(pl_id).y)
      id = c
    End If
  Next c

  Return id
End Function

Function get_centerest_pl_to_pass(pl_id As Integer) As Integer
  Dim max_dist As Integer = 10000
  Dim As Integer c, id

  For c = 0 To PL_N_TOT * 2-1
    If c = pl_id Or pl(c).team <> pl(pl_id).team Then Continue For 'don't pass himself
    If d_b_t_p(PITCH_MIDDLE_W,PITCH_MIDDLE_H,pl(c).x,pl(c).y) < max_dist Then
      max_dist = d_b_t_p(PITCH_MIDDLE_W,PITCH_MIDDLE_H,pl(c).x,pl(c).y)
      id = c
    End If
  Next c

  Return id
End Function

Function get_endline_pl_to_pass(pl_id As Integer) As Integer
  Dim max_dist As Integer = 10000
  Dim As Integer c, id

  For c = 2 To PL_N_TOT * 2-1
    If c = pl_id Then Continue For 'don't pass himself
    If pl(pl_id).team <> pl(c).team Then Continue For 'don't pass to a player of other team
    If Abs(PITCH_Y + PITCH_H * (pl(pl_id).team Xor 0) - pl(c).y) < max_dist Then
      max_dist = Abs(PITCH_Y + PITCH_H * (pl(pl_id).team Xor 0) - pl(c).y)
      id = c
    End If
  Next c

  Return id
End Function

Function get_ball_tile(team As Integer) As Integer
  Dim As Integer col, row, tile
  Dim As Integer x, y, x2,y2
  'this routine find in which tile is the ball
  For row = 0 To ROW_TOT_N -1 Step 1
    For col = 0 To COL_TOT_N -1 Step 1
      'draw the grid
      x = col * PITCH_W \ COL_TOT_N + PITCH_X
      y = row * PITCH_H \ ROW_TOT_N + PITCH_Y
      x2 = x + PITCH_W \ COL_TOT_N
      y2 = y + PITCH_H \ ROW_TOT_N

      'check if the ball is into a box of the grid
      If (ball.x > x) And (ball.x < x2) And (ball.y>y) And (ball.y < y2) Then
        Exit For, For
      End If
      tile +=1
    Next col
  Next row

  If team = 0 Then
    Return TILES_N_TOT - tile
  Else
    Return tile
  End If
End Function

Function get_passing_ball_speed (dist As Single) As Single
  Return Sqr(dist)* 4 * FRICTION
End Function

Function is_in_camera_crop (x As Single, y As Single, diam As Integer) As Integer
  If (x > camera.x - camera.w/2 - diam And x < (camera.x + camera.w\2 + diam))_
    And (y > camera.y - camera.y/2 - diam And y < (camera.y + camera.h\2 + diam)) Then
    Return 1
  Else
    Return 0
  End If
End Function

Function is_ball_slidable (c As Integer) As Integer
  'if the pl slider is not receiving the ball and if
  'the ball distance is into a specified range (in this case >30 <50)
  '(...) and also important: the ball.z must be less than a fixed value
  If (PL_ball_owner_id <> c) And (PL_target_id <> c)_
    And (d_b_t_p(pl(c).x, pl(c).y,ball.x, ball.y)) < 50 _
    And (d_b_t_p(pl(c).x, pl(c).y,ball.x, ball.y)) > 30 _
    And ball.z < 5 Then
    Return 1
  Else
    Return 0
  End If
End Function

Function is_ball_headkickable (c As Integer) As Integer
  'if the ball is near and its z value is greater than a fixed value
  'then the player tries to hit it with headkick
  If (PL_ball_owner_id <> c) And (d_b_t_p(pl(c).x, pl(c).y,ball.x, ball.y)) < 40 _
    And ball.z > 6 And ball.z < 30 Then
    Return 1
  Else
    Return 0
  End If
End Function

Function is_ball_controllable_by_human (c As Integer) As Integer
  If d_b_t_p(pl(c).x,pl(c).y, ball.x,ball.y) < 13 And ball.z < 6 Then
    Return 1
  Else
    Return 0
  End If
End Function

Function is_in_pl_fieldview (c As Integer, pl_to_pass As Integer) As Integer
  ' I think I've to revwrite againt this function :(
  If a_b_t_p (pl(c).x, pl(c).y, pl(pl_to_pass).x, pl(pl_to_pass).y) > _2PI_1_8 And _
    a_b_t_p (pl(c).x, pl(c).y, pl(pl_to_pass).x, pl(pl_to_pass).y) < _2PI_7_8 Then
    If Abs(pl(c).rds - a_b_t_p (pl(c).x, pl(c).y, pl(pl_to_pass).x, pl(pl_to_pass).y)) < PI_2 Then
      Return 1
    Else
      Return 0
    End If
  Else
    If a_b_t_p (pl(c).x, pl(c).y, pl(pl_to_pass).x, pl(pl_to_pass).y) < _2PI_1_8 And _
      Abs(pl(c).rds - a_b_t_p (pl(c).x, pl(c).y, pl(pl_to_pass).x, pl(pl_to_pass).y) + _2PI_1_8) < PI_2 Then
      Return 1
    End If
    If a_b_t_p (pl(c).x, pl(c).y, pl(pl_to_pass).x, pl(pl_to_pass).y) > _2PI_7_8 And _
      Abs(pl(c).rds - a_b_t_p (pl(c).x, pl(c).y, pl(pl_to_pass).x, pl(pl_to_pass).y) - _2PI_1_8) < PI_2 Then
      Return 1
    End If
    Return 0
  End If
  Return 0
End Function

'GFX INIT--------------------------------------------------------------------------------
ScreenRes SCREEN_W,SCREEN_H,24,2,0 ' Sets the graphic mode
Width SCREEN_W\8, SCREEN_H\14
ScreenSet 1, 0
Cls
WindowTitle GAME_NAME + " " + Str(GAME_VERSION) + " by " + Str(GAME_AUTHOR)
'MAIN------------------------------------------------------------------------------------
'hides the mouse
'SetMouse 320, 240, 0

load_tact()
load_behavior()
init_players_proprietes()
load_bitmap()
'kits are now custom painted by me, but You may use #define colors on the top of the file
'Dim c_1 As UInteger
'Dim c_2 As UInteger
'Dim c_3 As UInteger
'c_1 = &h550000:c_2 = &hFFFFFF:c_3 = &hFF20FF
'paint_kits  (c_1, c_2, c_3,c_1 Xor &hFFFFFF, c_2 Xor &hFFFFFF, c_3 Xor &hFFFFFF)
paint_kits(C_YELLOW, C_BLACK,C_YELLOW, C_BLUE, C_WHITE, C_BLUE )'BVB - FCSchalke

'check if the bitmaps have been correctly loaded
'check_bitmap()

draw_intro()

ball_put_on_centre()
Match_time_start = Timer
Do
  If InKey = Chr(255,107) Then Exit Do 'if the user clicks the X button on the window then ... bye bye JASC
  'get_user_input()
  check_pl_collisions()
  update_players()
  update_ball()
  ball_border_pitch_limit_check()
  camera_update_position()

  If PL_ball_owner_id >= 0 Then
    PL_ball_owner_delay -= 1
    If PL_ball_owner_delay <= 0 Then
      PL_ball_owner_delay = PL_DELAY_TIME*2
      PL_ball_owner_id = -1
    End If
  End If

  'graphic output
  ScreenLock ' Lock the screen
  ScreenSet workpage, workpage Xor 1 ' Swap work pages.
  Cls

  draw_pitch()
  draw_top_net()

  If (DEBUG) Then
    'draw_grid()
    '        dim d as Integer
    '        dim a as Integer
    '        dim temp_String as String

    draw_grid()

    '        print "Goal 0: "; goal_team_0,"Goal 1: ";goal_team_1
    Print "ball tile 0: "; get_ball_tile(0)
    Print "ball tile 1: "; get_ball_tile(1)
    '        print "nearest team 0 id:"; get_nrst_pl_ball(0); " nr "; pl(get_nrst_pl_ball(0)).number, _
    '        "nearest team 1 id:"; get_nrst_pl_ball(1); " nr "; pl(get_nrst_pl_ball(1)).number
    '
    Print "ball.x  ball.y  speed rds z"
    Print Using "####.##"; ball.x;" "; ball.y;" "; ball.speed;" "; ball.rds;" "; ball.z
    Print "key pressed: "; key_pressed

    '        print "     id   number    x     y    speed  rds delay  isincrop"
    '
    '        for d = 0 to PL_N_TOT * 2 - 1
    '            print using "####.##"; pl(d).id, pl(d).number, pl(d).x, pl(d).y, pl(d).speed,_
    '            pl(d).rds;pl(d).delay; is_in_camera_crop(pl(d).x, pl(d).y, 10),_
    '            get_tact_tile(d)
    '        next d
    '        print "PL_target_id ";PL_target_id
    '        print "PL_ball_owner_id ";PL_ball_owner_id
    '        print "MATCH_event ";MATCH_event
    '        'Debug
    '        for d = 0 to 9
    '            temp_string = ""
    '            for a = 0 to 35
    '                temp_string += str(tct_tile(d,a))
    '            next a
    '            draw string (0, 300 + (d*10)), temp_string
    '        next d
    Line (pl(get_nrst_pl_ball(0)).x-c_x_o, pl(get_nrst_pl_ball(0)).y-c_y_o)-_
    (pl(get_endline_pl_to_pass(get_nrst_pl_ball(0))).x-c_x_o,pl(get_endline_pl_to_pass(get_nrst_pl_ball(0))).y-c_y_o), 0

    Line (pl(get_nrst_pl_ball(1)).x-c_x_o, pl(get_nrst_pl_ball(1)).y-c_y_o)-_
    (pl(get_endline_pl_to_pass(get_nrst_pl_ball(1))).x-c_x_o,pl(get_endline_pl_to_pass(get_nrst_pl_ball(1))).y-c_y_o), 0

  End If

  draw_players()

  draw_ball()
  draw_bottom_net()
  draw_bottom_info()
  Draw String (20,20), Str((Timer - Match_time_start)\2) + " min"

  workpage Xor = 1 ' Swap work pages.
  ScreenSync 'wait for vsync
  ScreenUnLock ' Unlock the page to display what has been drawn on the screen

  Sleep SLEEP_TIME, 1 ' Slow down the program to prevent CPU overheating :)
  'this is a very early version of the timer
  If Timer - Match_time_start > 180 Then Exit Do
Loop Until MultiKey(SC_ESCAPE)

draw_aknowledgements()
delete_bitmap()
